#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
   
#include "head.h"

int *nv,*s_nv,*p_nv,*n_nv,*ps_nv,*ns_nv,*ans,*panswer,nans,
  *clause,**pclause,*rsell, *rlit ;

int n,t,presentt,literals,s_literals;

void keep_area(),set_p(),chg_ans(),make_f(),make_predicate(),
  ans_out(),dimacs_yes();
  
int   count_nans();

main(argc,argv)
     int argc;
     char **argv;
{
   int selin;

   printf("\n*** %dSAT-Generator for Satisfiable CNF Predicates ***\n\n",XSAT);
   if (argc > 2)
     {
	printf("Usage: %s {number}\n",*argv);
	exit(-1);
     }
   else 
     {
	if (argc == 2)
	  {
	     n= chg_num(*(argv+1));
	     if((n<=0)||(n>MAX_LIT))
	       {
		  printf("Argument's value isn't between 1 and %d\n",
			 MAX_LIT);
		  exit(-1);
	       }
	  }
	else
	  {
	     do
	       {
		  printf("How many variables ? 1 ... %d   ",
			 MAX_LIT);
		  scanf("%d",&n);
	       }while((n <= 0)||(n > MAX_LIT));
	  }
     }
   keep_area1();
   set_p1();
   do
     {
	printf("Literal Distribution\n");
	printf("   (0) Specify Literal Distribution\n");
	printf("   (1) Flat Distribution\n");
	printf("   (2) Normal Distribution\n");
	printf("   (3) Input Ratio(Clause/Variable)\n");
	printf("Select[ 0 - 3 ]:   ");
	scanf("%d",&selin);
     }while((selin<0)||(selin>3));
   switch(selin)
     {
      case 0: in_num_lit(); break;
      case 1: in_same_dat(); break;
      case 2: seiki_bunpu(); break;
      case 3: ratio_in(); break;
     }
   init_2();
   keep_area();
   set_p();
   rmake_dat(panswer,n,0,2,0);
   keep_area2();
   set_p2();
   init_3();
   while(t > count_nans())
     {
	chg_ans();
     }
   make_f();
   make_predicate();
   out_lit();
   ans_out();
   out_pred();
   dimacs_yes();
   dimacs_out();
}

void keep_area() 
{
   if ((ans = (int *)malloc(sizeof(int)*n))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
}

void set_p()
{
   panswer = ans;
}

int count_nans()
{
   int i,tmp;

   tmp=0;
   for(i=0; i<n; i++)
     {
	if(*(panswer+i))
	  {
	     tmp += *(p_nv+i);
	  }
	else
	  {
	     tmp += *(n_nv+i);
	  }
     }
   return tmp;
}

void chg_ans()
{
   int k,ks,l,np,nn;
   static int find=0;

   fill_dat(rsell,(n+1),1);
   while(find==0)
     {
	ks=num_rand(0,*(rsell+n));
	k=*(rsell+ks);
	np = *(p_nv+k);
	nn = *(n_nv+k);
	l = *(panswer+k);
	if(l)
	  {
	     if(np<nn)
	       {
		  *(panswer+k)=0;
		  find=1;
	       }
	     else
	       {
		  removel(rsell,ks,*(rsell+n),n);
	       }
	  }
	else
	  {
	     if(np>nn)
	       {
		  *(panswer+k)=1;
		  find=1;
	       }
	     else
	       {
		  removel(rsell,ks,*(rsell+n),n);
	       }
	  }
	if(*(rsell+n)==0)
	  {
	     perror("make answer failed \n");
	     exit(-1);
	  }
     }
}

void make_f()
{
   int i,fin,tmps,tmp;

   fin=0;
   fill_dat(rsell,n+1,1);
   for(i=0; i<t; i++)
     {
	do
	  {
	     tmps=num_rand(0,*(rsell+n));
	     fin=0;
	     tmp=*(rsell+tmps);
	     if(*(panswer+tmp)==1)
	       {
		  if(*(p_nv+tmp)>0)
		    {
		       *(*(pclause+i)+tmp)=1;
		       *(*(pclause+i)+2*n)+=1;
		       *(p_nv+tmp)-=1;
		       literals-=1;
		       fin=1;
		    }
		  else
		    {
		       removel(rsell,tmps,*(rlit+2*n),2*n);
		    }
	       }
	     else
	       {
		  if(*(n_nv+tmp)>0)
		    {
		       *(*(pclause+i)+n+tmp)=1;
		       *(*(pclause+i)+2*n)+=1;
		       *(n_nv+tmp)-=1;
		       literals-=1;
		       fin=1;
		    }
		  else
		    {
		       removel(rsell,tmps,*(rlit+2*n),2*n);
		    } 
	     }
	}while(fin==0);
     }
}

void make_predicate()
{
   int i,count,tmps,tmp,find;

   fill_dat(rlit,2*n+1,1);
   for(i=0; i<t; i++)
     {
	count=0;
	while(count != (XSAT-1))
	  {
	     find=0;
	     while(find==0)
	       {
		  tmps=num_rand(0,*(rlit+2*n));
		  tmp=*(rlit+tmps);
		  if(*(nv+tmp)>0)
		    {
		       *(*(pclause+i)+tmp)+=1;
		       *(*(pclause+i)+2*n)+=1;
		       *(nv+tmp)-=1;
		       literals-=1;
		       count+=1;
		       find=1;
		    }
		  else
		    {
		       removel(rlit,tmps,*(rlit+2*n),2*n);
		    }
	       }
	  }
     }
}

void ans_out()
{
   int i;
   
   printf("###  Initial Truth Assignment  ###\n\n");
   for(i=0; i<n; i++)
     {
	if(*(panswer+i)==0)
	  {
	     printf("x%d",i+1);
	  }
	else
	  {
	     printf("x%d'",i+1);
	  }
	if(i != n-1)
	  printf("+");
     }
   printf("\n\n");
}
   
void dimacs_yes()
{
   printf("\n");
   printf("c\n");
   printf("c NOTE: Satisfiable\n");
   printf("c\n");
}
